/*-----------------------------------------------------------------*/
/*                         TEST LECTEUR GCI                        */
/*                                                                 */
/*                         Version 1.0,                            */
/*                                                                 */
/* Creation : 14 Fevrier 1991                                      */
/* Revision : 15 Fevrier 1991                                      */
/* Auteur    : G. Grimonprez                                       */
/*                                                                 */
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
/*                            INCLUDES SYSTEME                     */
/*-----------------------------------------------------------------*/

#include <iostream.h>
#include <conio.h>
#include <setjmp.h>
#include <ctype.h>
#include <process.h>
#include "rs232cc.h"

/*-----------------------------------------------------------------*/
/*                            DEFINES                              */
/*-----------------------------------------------------------------*/

#define WORD    unsigned int
#define BYTE    unsigned char

#define MAX_BLOC    256

/*                        PROTOCOLE TLP224                         */

#define ETX                     3

#define ACK_LECTEUR             0x60
#define NAK_LECTEUR             0xe0

#define SELECTION_MODE_COUPLEUR 0x02
#define COUPLEUR_ASYNCHRONE     0x02
#define COUPLEUR_SYNCHRONE      0x03

#define RESET_CARTE             0x6e
#define MISE_HORS_TENSION_CARTE 0x4d
#define ORDRE_ENTRANT_LECTEUR   0xda
#define ORDRE_SORTANT_LECTEUR   0xdb

/*                            ORDRES ISO  Cartes COS               */

#define ORDRE_ISO_INCORRECT     0xff
#define ORDRE_ISO_STATUS        0xf2

/*-----------------------------------------------------------------*/
/*                            DECLARATIONS GLOBALES                */
/*-----------------------------------------------------------------*/

jmp_buf jmp_buffer;  /* point de retour pour recuperation d'erreur */

/*-----------------------------------------------------------------*/
/*                            INCLUDES                             */
/*-----------------------------------------------------------------*/

/*------ ERREUR ---------------------------------------------------*/

 void erreur(char message[])
{

 cout << endl << "ERREUR : " << message << endl;
 longjmp(jmp_buffer,0);
}

/*-----------------------------------------------------------------*/
/*                            FONCTIONS                            */
/*-----------------------------------------------------------------*/

/*------ EMETTRE_QUARTET_NORME_TLP224 -----------------------------*/

// ****** A COMPLETER ***********************************************

/*------ EMETTRE_BYTE_NORME_TLP224 --------------------------------*/

// ****** A COMPLETER ***********************************************

/*------ EMETTRE_MESSAGE_NORME_TLP224 -----------------------------*/

//****** A COMPLETER ************************************************

/*------ RECEVOIR_QUARTET_NORME_TLP224 ----------------------------*/

//****** A COMPLETER ***********************************************

/*------ RECEVOIR_OCTET_NORME_TLP224 ------------------------------*/

//****** A COMPLETER ************************************************

/*------ RECEVOIR_MESSAGE_NORME_TLP224 ----------------------------*/

//****** A COMPLETER ************************************************

/*------ AFFICHER_BLOC --------------------------------------------*/

void afficher_bloc(WORD longueur_bloc,BYTE bloc[MAX_BLOC])
{

 cout << endl << "Longueur du message recu : " << longueur_bloc << endl;
 if(bloc[0]==0) {
    dump("Reponse de la carte",&bloc[1],longueur_bloc-1);
    return;
    }
 dump("Bloc recu",bloc,(int)longueur_bloc);
 switch(bloc[0]) {
 case 0x04:
      erreur("Commande coupleur inconnue");
      break;
 case 0x09:
      erreur("En-tete de message<>ACK_LECTEUR ou NAK_LECTEUR");
      break;
 case 0x10:
      erreur("L'octet TS de la reponse au reset n'est pas valide");
      break;
 case 0x11:
      erreur("L'octet INS dans un ordre ISO n'est pas valide");
      break;
 case 0x12:
      erreur("Message trop long (>64 octets)");
      break;
 case 0x13:
      erreur("Erreur de lecture depuis la carte asynchrone");
      break;
 case 0x14:
      erreur("Type de carte inconnu");
      break;
 case 0x15:
      erreur("Carte hors-tension");
      break;
 case 0x16:
      erreur("Tension de programmation non valide");
      break;
 case 0x17:
 case 0x18:
      erreur("Protocole de communication inconnu");
      break;
 case 0x19:
      erreur("Acces illegal au bus externe");
      break;
 case 0x1A:
      erreur("Longueur LN de l'ordre ISO <> longueur reelle des donnees");
      break;
 case 0x1B:
      erreur("Nombre d'arguments de la commande ISO incorrect");
      break;
 case 0x1C:
      erreur("Sous-fonction inconnue");
      break;
 case 0x1D:
      erreur("L'octet de controle TCK de la reponse au reset est errone");
      break;
 case 0x1E:
      erreur("La memoire carte est absente ou non modifiable");
      break;
 case 0x1F:
      erreur("Erreur d'ecriture dans la memoire carte");
      break;
 case 0xA0:
      erreur("Erreur dans le reponse au reset");
      break;
 case 0xA2:
      erreur("Carte muette");
      break;
 case 0xA3:
      erreur("Erreur de parite entre le coupleur et la carte");
      break;
 case 0xE4:
      erreur("La carte a emis un procedure byte invalide");
      break;
 case 0xE5:
      erreur("La carte a interrompu un echange");
      break;
 case 0xE7:
      erreur("SW1 et SW2 <> de 90 00");
      break;
 case 0xF7:
      erreur("La carte a ete retiree en cours d'operation");
      break;
 case 0xFB:
      erreur("Carte absente");
      break;
 default:
      erreur("Reponse du coupleur non repertoriee");
      break;
     }
}

/*------ ORDRE_RESET ----------------------------------------------*/

void ordre_reset(void)
{
 BYTE bloc[MAX_BLOC];
 WORD longueur_bloc;

 bloc[0]=RESET_CARTE;
 bloc[1]=0;
 bloc[2]=0;
 bloc[3]=0;
 emettre_message_norme_tlp224(4,bloc);
 recevoir_message_norme_tlp224(longueur_bloc,bloc);
 afficher_bloc(longueur_bloc,bloc);
 switch(bloc[1]) {
	case 0x28:
		  cout << "Coupleur en mode TLP" << endl;
		  break;
	case 0x01:
		  cout << "Coupleur en mode CS" << endl;
		  break;
	default  :
		  cout << "Type de coupleur inconnu" << endl;
		  break;
       }
 switch(bloc[2]) {
	case 0x02:
		  cout << "Carte asynchrone" << endl;
		  break;
	case 0x03:
		  cout << "GPM 256 (1200)" << endl;
		  break;
	case 0x04:
		  cout << "GPM 416 (1301)" << endl;
		  break;
	default  :
		  cout << "Type de carte inconnu" << endl;
		  break;
       }
 cout << "Longueur de la reponse carte " << (int)bloc[3] << " octets" << endl;
 switch(bloc[4]) {
	case 0x3B:
		  cout << "9600 bauds, parite paire, convention AFNOR"<<endl;
		  break;
	case 0x3F:
		  cout << "9600 bauds, parite paire, convention BULL"<<endl;
		  break;
	default  :
		  cout << "Octet TS inconnu inconnu"<<endl;
		  break;
       }
}

/*----- ORDRE_HORS_TENSION ----------------------------------------*/

void ordre_hors_tension(void)
{
 BYTE bloc[MAX_BLOC];
 WORD longueur_bloc;

 bloc[0]=MISE_HORS_TENSION_CARTE;
 emettre_message_norme_tlp224(1,bloc);
 recevoir_message_norme_tlp224(longueur_bloc,bloc);
 afficher_bloc(longueur_bloc,bloc);
}

/*----- LECTEUR ---------------------------------------------------*/

void lecteur(BYTE mode)
{
 BYTE bloc[MAX_BLOC];
 WORD longueur_bloc;

 bloc[0]=SELECTION_MODE_COUPLEUR;
 bloc[1]=mode;
 bloc[2]=0;
 emettre_message_norme_tlp224(3,bloc);
 recevoir_message_norme_tlp224(longueur_bloc,bloc);
 afficher_bloc(longueur_bloc,bloc);
}

/*-----------------------------------------------------------------*/
/*                            ORDRES ISO   T=0 7816-3              */
/*-----------------------------------------------------------------*/

/*------ ORDRE_ENTRANT --------------------------------------------*/

void ordre_entrant(BYTE cl, BYTE ins, BYTE a1, BYTE a2, BYTE ln,
		   BYTE data[MAX_BLOC])
{
 BYTE bloc[MAX_BLOC];
 WORD i,longueur_bloc;

 bloc[0]=ORDRE_ENTRANT_LECTEUR;
 bloc[1]=cl;
 bloc[2]=ins;
 bloc[3]=a1;
 bloc[4]=a2;
 bloc[5]=ln;
 for(i=0;i<ln;i++) bloc[i+6]=data[i];
 emettre_message_norme_tlp224(6+ln,bloc);
 recevoir_message_norme_tlp224(longueur_bloc,bloc);
 afficher_bloc(longueur_bloc,bloc);
}

/*----- ORDRE_SORTANT ----------------------------------------------*/

void ordre_sortant(BYTE cl, BYTE ins, BYTE a1, BYTE a2, BYTE ln)
{
 BYTE bloc[MAX_BLOC];
 WORD longueur_bloc;

 bloc[0]=ORDRE_SORTANT_LECTEUR;
 bloc[1]=cl;
 bloc[2]=ins;
 bloc[3]=a1;
 bloc[4]=a2;
 bloc[5]=ln;
 emettre_message_norme_tlp224(6,bloc);
 recevoir_message_norme_tlp224(longueur_bloc,bloc);
 afficher_bloc(longueur_bloc,bloc);
}

/*------ AIDE  -----------------------------------------------------*/

void aide(void)
{

 cout << endl <<"Demonstration lecteur GCI-100, test status cartes COS"
      << endl << endl;
 cout << "R : Reset de la carte"<<endl;
 cout << "H : mise Hors-tension de la carte"<<endl;
 cout << "E : Emission d'un ordre entrant incorrect"<<endl;
 cout << "S : ordre Sortant de status pour carte COS"<<endl;
 cout << "A : Mise du lecteur en mode asynchrone"<<endl;
 cout << "Y : Mise du lecteur en mode synchrone"<<endl;
 cout << "D : Dump d'une carte GPM 256"<<endl;
 cout << "? : Aide"<<endl;
 cout << "F : Fin de travail"<<endl<<endl;
}

/*------ MAIN  -----------------------------------------------------*/

void main(void)
{
 char cmd;
 BYTE bloc[MAX_BLOC];

 clrscr();
 aide();
 init_controleur(INTERRUPT,COM1,9600,8,1,SANS,10);
 setjmp(jmp_buffer);
 do {
     cout << "GCI ? " << flush;
     cmd=toupper(getche());
     cout << endl;
     switch(cmd) {
	    case 'D':ordre_sortant(0,0xb0,0,0,32);
		     break;
	    case 'A':lecteur(COUPLEUR_ASYNCHRONE);
		     break;
	    case 'Y':lecteur(COUPLEUR_SYNCHRONE);
		     break;
	    case 'R':
		     ordre_reset();
		     break;
	    case 'H':
		     ordre_hors_tension();
		     break;
	    case 'E':
		     ordre_entrant(0,ORDRE_ISO_INCORRECT,0,0,1,bloc);
		     break;
	    case 'S':
		     ordre_sortant(0,ORDRE_ISO_STATUS,0,0,0x0c);
		     break;
	    case '?':
		     aide();
		     break;
	  case 'F':
		   break;
	  default :
		   cout << "Commande incorrecte, ? pour aide"<<endl;
		   break;
	  }
    }
  while(cmd!='F');
  restaure_controleur();
  exit(1);
}
